                             '******************************************************************************

'******* TERMOMETR Z WODOODPORNY Z WYKORZYSTANIEM SONDY DS18B20 ***************
'******* WYKONANA GAJDOSZ PIOTR, E-MAIL :gajpiotr@interia.eu *****************

'******************************************************************************


$regfile = "m8def.dat"                                      ' procesor
$crystal = 8000000                                          'taktowanie


'************** KONFIGURACJE I DEKLARACJE ZMIENNEYCH ***************************


Config 1wire = Pinb.6                                       '1wire

Config Pind.0 = Output                                      ' A dekodera
Config Pind.1 = Output                                      ' B dekodera
Config Pind.2 = Output                                      ' C dekodera
Config Pind.3 = Output                                      ' D dekodera

Config Pind.4 = Output                                      ' zatrzask dekodera 4
Config Pind.5 = Output                                      ' zatrzask dekodera 3
Config Pind.6 = Output                                      ' zatrzask dekodera 1
Config Pind.7 = Output                                      ' zatrzask dekodera 2

Portd.4 = 0
Portd.5 = 0
Portd.6 = 0
Portd.7 = 0

Config Pinc.3 = Output                                      'kropka wys 4
Config Pinc.2 = Output                                      'kropka wys 3
Config Pinc.1 = Output                                      'kropka wys 2
Config Pinc.0 = Output                                      'kropka wys 1

Reset Portc.3
Reset Portc.2
Reset Portc.1
Reset Portc.0


Set Portd.0
Set Portd.1
Set Portd.2
Set Portd.3

Dd Alias Portd.3                                            ' nazwy pinow wejsciowych dekodera
Ad Alias Portd.0
Bd Alias Portd.1
Cd Alias Portd.2

Le4 Alias Portd.4                                           ' nazwy zatrzaskow
Le3 Alias Portd.5
Le1 Alias Portd.6
Le2 Alias Portd.7

Kr1 Alias Portc.0                                           ' nazwy kropek
Kr2 Alias Portc.1
Kr3 Alias Portc.2
Kr4 Alias Portc.3



Declare Sub Na_wys                                          ' podprogram do wybrania wartosci ustawionych na ABCD dekoderow


Dim L As Long , K As Long , P As Word , D As Word , Tr As Word , C As Word
Dim Lsb As Byte , Msb As Byte , T As Single , S As String * 6 ,
Dim B As Bit
Dim A As Long

Ad = 0                                                      'ustawienie wygaszenia wszystkich wyswietlaczy do momentu wykonania pierwszego programu
Bd = 1
Cd = 0
Dd = 1



Do


   1wreset
   1wwrite &HCC                                             ' skip rom - pominiecie identyfidkacji czujnika (bo jest tylko jeden)
   1wwrite &H44                                             ' dokokanie pomiaru
   Waitms 750

   1wreset
   1wwrite &HCC
   1wwrite &HBE                                             ' rozkaz powodujacy ze mozemy odczytywac dane z magistrali
   Lsb = 1wread()                                           'odczyt najnizszego bajta danych
   Msb = 1wread()                                           ' odczyt wyzszego bajta
   T = Msb * 256
   T = T + Lsb
   T = T / 16                                               ' konwersja na typ single
   If Msb.7 = 1 Then T = T -4096                            'sprawdzenie bitu znaku (1 ujemny, 0 nieujemny, w przyp. ujemnego korekta wartosci



   If T < 10 Then                                           ' ustelenie kropki: jesli <10 to odblokowanie dekodera1
            Reset Le1                                       ' ustawienie na wys1 wygaszenia
            Ad = 1
            Bd = 1
            Cd = 1
            Dd = 1
            Set Le1                                         'zablokowanie dekodera1 (Latch Enable)
            B = 1                                           'ustawienie zmiennej B=1 po to, aby w dalszej czesci programu nie wyswietlac nic na wys1 ( bo temp jest <10)
            Reset Kr1                                       ' wlaczenie kropki na drugim wyswietlaczu
            Set Kr2
            Reset Kr3
            Reset Kr4
            End If


      If T >= 10 Then                                       ' jesli temp >10 i <100 to
        If T < 100 Then
                     B = 0                                  'ustawenie zmiennej b=0 po to, zeby mozna bylo wyswietlic cyfre na wys1
                     Set Kr2                                ' wlaczenie kropki na wys2
                     Reset Kr1
                     Reset Kr3
                     Reset Kr4
                     End If
         End If



         If T >= 100 Then                                   'jesli temp >100 to dzielimy ja przez 10. Jesli temperatura w rzeczywistosci wynosi 123,56 st. to normalnie wyswietli nam 235,6 dlatego musimy ja zmiejszyc o 10.
               T = T / 10
               B = 0                                        ' zmienna b=0 po to aby mozna byo wyswietlac na wys1
               Set Kr3                                      'wyswietlenie kropki na wys3
               Reset Kr2
               Reset Kr1
               Reset Kr4
               End If




   A = T * 100                                              ' a to temperatura pomnozona przez 100

   C = A Mod 10                                             ' podzial temperatury z formy 1234st na cztery cyfry dajace sie wyswietlic na wyswietlaczach
   L = C                                                    ' dla np A=1234, mod zwroci 4.
   Reset Le4                                                'odblokowanie dekodera4, wybranie z instrukcji Select Case binarnych wartosci ABCD odpowiadajacych 4
   Gosub Na_wys                                             'zablokowanie dekodera
   Set Le4

   A = A / 10                                               'zminejszenie wartosci temperatury poprzez podzial przez 10, czyli dla 1234 mamy 123,4
   Tr = A Mod 10                                            ' mod zwroci teraz 3
   L = Tr                                                   ' odblokwoanie dekodera i wybranie wartosci ABCD z instruckji Select Case,
   Reset Le3                                                '  zablokowanie dekodera
   Gosub Na_wys
   Set Le3

   A = A / 10                                               'identycznie jak wyzej
   D = A Mod 10
   L = D
   Reset Le2
   Gosub Na_wys
   Set Le2

   If B = 0 Then                                            ' jesli zmianna B =0 to znaczy ze temperatura jest na pewno >10 to znaczy ze na wys1 musi cos byc. Warunek niespelniony gdy temp <10 wtedy wys1 jest wygaszony
      A = A / 10
      P = A Mod 10
      L = P
      Reset Le1
      Gosub Na_wys
      Set Le1
   End If
Ad = 1
Bd = 1
Cd = 1
Dd = 1


Loop
End





'*************** PODPROGRAM WYBORU WARTOSCI NA PINY ABCD DEKODEROW *************

Sub Na_wys
   Select Case L

    Case 0 :                                                'zero
            Ad = 0
            Bd = 0
            Cd = 0
            Dd = 0
   Case 1 :                                                 'jeden
            Ad = 1
            Bd = 0
            Cd = 0
            Dd = 0
   Case 2 :                                                 'dwa
            Ad = 0
            Bd = 1
            Cd = 0
            Dd = 0
   Case 3 :                                                 'trzy
            Ad = 1
            Bd = 1
            Cd = 0
            Dd = 0
   Case 4 :                                                 'cztery
            Ad = 0
            Bd = 0
            Cd = 1
            Dd = 0
   Case 5 :                                                 'piec
            Ad = 1
            Bd = 0
            Cd = 1
            Dd = 0
   Case 6 :                                                 'szesc
            Ad = 0
            Bd = 1
            Cd = 1
            Dd = 0
   Case 7 :                                                 'siedem
            Ad = 1
            Bd = 1
            Cd = 1
            Dd = 0
   Case 8 :                                                 'osiem
            Ad = 0
            Bd = 0
            Cd = 0
            Dd = 1
   Case 9 :                                                 'dziewiec
            Ad = 1
            Bd = 0
            Cd = 0
            Dd = 1

   End Select
End Sub